window.timeline,
    outsideBanner = 800,
    defaultEase = Power3.easeInOut;

$(document).ready(init);

function init () {
    registerElements();
    addListeners();
    initBannerHover();
    setInitialAnimationState();
    composeAnimation();
    animateIn();
}

function registerElements () {
    this.$banner = $('#banner');
    this.$bannerImage = this.$banner.find('.banner-image');
    this.$bannerLeft = this.$banner.find('.banner-left');
    this.$bannerRight = this.$banner.find('.banner-right');
    this.$button = this.$banner.find('.button');
    this.$logo = this.$banner.find('.abn-logo');
    this.$phone = this.$banner.find('.phone');
    this.$appIcon = this.$banner.find('.app-icon');
    this.$primaryText = this.$banner.find('.primary-text');
    this.$alternateText = this.$banner.find('.alternate-text');
    this.$extraText = this.$banner.find('.extra-text');
}

function addListeners () {
    this.$banner.on('click', handleBannerClick);
}

function handleBannerClick (event) {
    event.preventDefault();
    window.open(clickTag);
}

function setInitialAnimationState()
{
    TweenMax.set($phone, {autoAlpha: 0, x: 110});
    TweenMax.set($appIcon, {autoAlpha: 0, x: 70});
}

function composeAnimation () {
    this.timeline = new TimelineLite({
        onComplete: animationComplete
    });
    this.timeline.to(this.$banner, 0.3, {autoAlpha: 1, ease: Sine.easeInOut});
    this.timeline.to(this.$bannerImage, 0.5, {autoAlpha: 1, ease: Sine.easeInOut});
    // this.timeline.to(this.$bannerRight, 0.5, {autoAlpha: 1, ease: Sine.easeInOut});
    // this.timeline.to(this.$logo, 1, {autoAlpha: 1, ease: Sine.easeInOut, delay: -0.3});
    this.timeline.to(this.$bannerImage, 0.5, {autoAlpha: 0, ease: Sine.easeInOut, delay: 0.5});
    this.timeline.to(this.$bannerLeft, 0.5, {autoAlpha: 1, ease: Sine.easeInOut});
    this.timeline.to(this.$primaryText, 1, {autoAlpha: 1, ease: Sine.easeInOut});
    // this.timeline.to(this.$appIcon, 0.5, {x: 0, autoAlpha: 1, ease: Sine.easeOut, delay: -0.15});
    this.timeline.to(this.$primaryText, 0.7, {autoAlpha: 0, delay:1.5});
    this.timeline.to(this.$alternateText, 1, {autoAlpha: 1});
    this.timeline.to(this.$alternateText, 0.7, {autoAlpha: 0, delay:1.5});
    this.timeline.to(this.$extraText, 1, {autoAlpha: 1});
    this.timeline.to(this.$phone, 0.5, {x: 0, autoAlpha: 1, delay: 0.3, ease: Sine.easeOut});
    this.timeline.to(this.$button, 0.6, {autoAlpha: 1});
    this.timeline.to(this.$button, 0.2, {scale: 1.05, delay: 0.3, rotation: 0.001, force3D:false});
    this.timeline.to(this.$button, 0.2, {scale: 1, rotation: 0.001, force3D:false});
}

function initBannerHover () {
    this.$banner.mouseover(function () {
        if (!window.hoverEnabled) return;
        // TODO: add mouseover animations

    }).mouseout(function () {
        if (!window.hoverEnabled) return;
        // TODO: add mouseout animations
    });
}

function animateIn () {
    this.timeline.restart();
}

function animationComplete () {
    window.hoverEnabled = true;
}